//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaMaracasVisuwxVtkBaseView_Info.h"
#include "bbcreaMaracasVisuPackage.h"
#include <vtkInteractorStyleBaseView.h>

namespace bbcreaMaracasVisu
{

InteractorwxVtkBaseView_model::InteractorwxVtkBaseView_model()
{
    _wxvtkbaseview = NULL;
}

InteractorwxVtkBaseView_model::~InteractorwxVtkBaseView_model()
{
}

void InteractorwxVtkBaseView_model::SetwxVtkBaseView( wxVtkBaseView *wxvtkbaseview)
{
    _wxvtkbaseview = wxvtkbaseview;
}

void InteractorwxVtkBaseView_model::AddThisInteractor()
{
    vtkInteractorStyleBaseView  *vtkinteractorstylebaseview = (vtkInteractorStyleBaseView*) (_wxvtkbaseview->GetInteractorStyleBaseView() );
    vtkinteractorstylebaseview->AddInteractorStyleMaracas( this );
}





class InteractorwxVtkBaseView : public InteractorwxVtkBaseView_model
{
    public:
        InteractorwxVtkBaseView( wxVtkBaseView_Info *box );
        ~InteractorwxVtkBaseView();
        virtual bool    OnLeftButtonDown();
        virtual bool    OnLeftButtonUp();
        virtual bool    OnMouseMove();
        virtual bool    OnRightButtonDown();
        virtual bool    OnRightButtonUp();
        virtual bool    OnLeftDClick();
        virtual bool    OnRightDClick();
private:
        wxVtkBaseView_Info      *_box;
        bool                    flagDrag;
};

InteractorwxVtkBaseView::InteractorwxVtkBaseView( wxVtkBaseView_Info *box  )
{
    _box            = box;
    flagDrag        = false;
}

InteractorwxVtkBaseView::~InteractorwxVtkBaseView()
{
}

bool InteractorwxVtkBaseView::OnLeftButtonDown()
{
    if (_box!=NULL)
    {
        if ( _box->bbGetInputInteractionType()==8 )
        {
            flagDrag=true;
        }
        if ( (_box->bbGetInputInteractionType()==1 ) && (_wxvtkbaseview!=NULL) )
        {
            _box->SetwxVtkBaseViewOutputs( _wxvtkbaseview );
            _box->bbSignalOutputModification();
            return false;
        } // if _vtkbaseview
    } // if _box
    return true;
}

bool InteractorwxVtkBaseView::OnLeftButtonUp()
{
    if (_box!=NULL)
    {
        if ( _box->bbGetInputInteractionType()==8 )
        {
            flagDrag=false;
        }
        if ( (_box->bbGetInputInteractionType()==2 ) && (_wxvtkbaseview!=NULL) )
        {
            _box->SetwxVtkBaseViewOutputs( _wxvtkbaseview );
            _box->bbSignalOutputModification();
            return false;
        } // if _vtkbaseview
    } // if _box
    return true;
}

bool InteractorwxVtkBaseView::OnMouseMove()
{
    if (_box!=NULL)
    {
        int intFlag;
        if (flagDrag==true) intFlag=1; else intFlag=0;
        bool ok=false;
        if ( (_box->bbGetInputInteractionType()==3 ) && (_wxvtkbaseview!=NULL) )
        {
            ok=true;
        } // if InteractionType 3
        if (( _box->bbGetInputInteractionType()==8 ) && (flagDrag==true) )
        {
            ok=true;
        } // if InteractionType 8
        if (( _box->bbGetInputInteractionType()==9 ) && (flagDrag==true) )
        {
            ok=true;
        } // if InteractionType 9
        if (ok==true)
        {
            _box->SetwxVtkBaseViewOutputs( _wxvtkbaseview );
            _box->bbSignalOutputModification();
            return false;
        } // if ok
    } // if _box
    return true;
}

bool InteractorwxVtkBaseView::OnRightButtonDown()
{
    if (_box!=NULL)
    {
        if ( _box->bbGetInputInteractionType()==9 )
        {
            flagDrag=true;
        }
        if ( (_box->bbGetInputInteractionType()==4 ) && (_wxvtkbaseview!=NULL) )
        {
            _box->SetwxVtkBaseViewOutputs( _wxvtkbaseview );
            _box->bbSignalOutputModification();
            return false;
        } // if _vtkbaseview
    } // if _box
    return true;
}

bool InteractorwxVtkBaseView::OnRightButtonUp()
{
    if (_box!=NULL)
    {
        if ( _box->bbGetInputInteractionType()==9 )
        {
            flagDrag=false;
        }
        if ( (_box->bbGetInputInteractionType()==5 ) && (_wxvtkbaseview!=NULL) )
        {
            _box->SetwxVtkBaseViewOutputs( _wxvtkbaseview );
            _box->bbSignalOutputModification();
            return false;
        } // if _vtkbaseview
    } // if _box
    return true;
}


bool InteractorwxVtkBaseView::OnLeftDClick()
{
    if (_box!=NULL)
    {
        if ( (_box->bbGetInputInteractionType()==6 ) && (_wxvtkbaseview!=NULL) )
        {
            printf("EED InteractorwxVtkBaseView::OnLeftDClick type=6 \n");
            _box->SetwxVtkBaseViewOutputs( _wxvtkbaseview );
            _box->bbSignalOutputModification();
            return false;
        } // if _vtkbaseview
    } // if _box
    return true;
}

bool InteractorwxVtkBaseView::OnRightDClick()
{
    if (_box!=NULL)
    {
        if ( (_box->bbGetInputInteractionType()==7 ) && (_wxvtkbaseview!=NULL) )
        {
            _box->SetwxVtkBaseViewOutputs( _wxvtkbaseview );
            _box->bbSignalOutputModification();
            return false;
        } // if _vtkbaseview
    } // if _box
    return true;
}

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,wxVtkBaseView_Info)
BBTK_BLACK_BOX_IMPLEMENTATION(wxVtkBaseView_Info,bbtk::AtomicBlackBox);

void wxVtkBaseView_Info::SetwxVtkBaseViewOutputs(wxVtkBaseView *wxvtkbaseview )
{
    if (wxvtkbaseview!=NULL)
    {
        bbSetOutputvtkRenderer( wxvtkbaseview->GetRenderer() );
        bbSetOutputDirection( wxvtkbaseview->GetDirection() );
        bbSetOutputwxVtkBaseView(wxvtkbaseview);
        vtkBaseData *vtkbasedata = wxvtkbaseview->GetVtkBaseData();
        if (vtkbasedata!=NULL)
        {
            marImageData *marimagedata = vtkbasedata->GetMarImageData();
            if (marimagedata!=NULL)
            {
                bbSetOutputImage( marimagedata->GetImageData() );
            } // MarImageData
            std::vector<double> LstWindowColorLevel;
            LstWindowColorLevel.push_back( vtkbasedata->GetColorWindow() );
            LstWindowColorLevel.push_back( vtkbasedata->GetColorLevel() );
            bbSetOutputWindowColorLevel( LstWindowColorLevel );
            
            std::vector<double> lstPoint;
            lstPoint.push_back( vtkbasedata->GetX() );
            lstPoint.push_back( vtkbasedata->GetY() );
            lstPoint.push_back( vtkbasedata->GetZ() );
            bbSetOutputPoint( lstPoint );

            int pointMouseX,pointMouseY,pointMouseZ;
            vtkbasedata->GetPointMouse(pointMouseX,pointMouseY,pointMouseZ); 
            std::vector<double> lstPointMouse;
            lstPointMouse.push_back( pointMouseX );
            lstPointMouse.push_back( pointMouseY );
            lstPointMouse.push_back( pointMouseZ );
            bbSetOutputPointMouse( lstPointMouse );

            double normal[3];
            std::vector<double> lstNormal;
            wxvtkbaseview->GetNormal( normal );
            lstNormal.push_back( normal[0] );
            lstNormal.push_back( normal[1] );
            lstNormal.push_back( normal[2] );
            bbSetOutputNormal( lstNormal );
            
            bbSetOutputInterpolation( vtkbasedata->GetInterpolate() );
        }  // BaseData
    } // if wxvtkbaseview
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void wxVtkBaseView_Info::Process()
{
// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')
    if (bbGetInputInteractionType()==0)
    {
        SetwxVtkBaseViewOutputs( bbGetInputwxVtkBaseView() );
    }
    
    if (firsttime==true)
    {
        firsttime=false;
        if (bbGetInputInteractionType()!=0)
        {
            SetwxVtkBaseViewOutputs( bbGetInputwxVtkBaseView() );
            
            interactorwxvtkbaseview    = new InteractorwxVtkBaseView( this  );
            if (bbGetInputwxVtkBaseView()!=NULL)
            {
                interactorwxvtkbaseview->SetwxVtkBaseView(  bbGetInputwxVtkBaseView() );
                interactorwxvtkbaseview->AddThisInteractor();
            } // if wxVtkBaseView
            
            interactorwxvtkbaseview2    = new InteractorwxVtkBaseView( this  );
            if (bbGetInputwxVtkBaseView2()!=NULL)
            {
                interactorwxvtkbaseview2->SetwxVtkBaseView(  bbGetInputwxVtkBaseView2() );
                interactorwxvtkbaseview2->AddThisInteractor();

//                vtkInteractorStyleBaseView  *vtkinteractorstylebaseview = (vtkInteractorStyleBaseView*) (bbGetInputwxVtkBaseView2()->GetInteractorStyleBaseView() );
//                vtkinteractorstylebaseview->AddInteractorStyleMaracas( interactorwxvtkbaseview2 );
            } // if wxVtkBaseView2
            
            interactorwxvtkbaseview3    = new InteractorwxVtkBaseView( this  );
            if (bbGetInputwxVtkBaseView3()!=NULL)
            {
                interactorwxvtkbaseview3->SetwxVtkBaseView(  bbGetInputwxVtkBaseView3() );
                interactorwxvtkbaseview3->AddThisInteractor();

//                vtkInteractorStyleBaseView  *vtkinteractorstylebaseview = (vtkInteractorStyleBaseView*) (bbGetInputwxVtkBaseView3()->GetInteractorStyleBaseView() );
//                vtkinteractorstylebaseview->AddInteractorStyleMaracas( interactorwxvtkbaseview3 );
            } // if wxVtkBaseView3
            
            bbSetOutputInteractorwxVtkBaseView_model(   interactorwxvtkbaseview  );
            bbSetOutputInteractorwxVtkBaseView_model2(  interactorwxvtkbaseview2 );
            bbSetOutputInteractorwxVtkBaseView_model3(  interactorwxvtkbaseview3 );
        } // if InteractionType !=0
    } // if firsttime
    
    bbSetOutputBox_wxVtkBaseView_Info( this );
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void wxVtkBaseView_Info::bbUserSetDefaultValues()
{
//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
    firsttime=true;
	std::vector<double> LstWindowColorLevel;
	LstWindowColorLevel.push_back( 1000 );
	LstWindowColorLevel.push_back( 500 );
    bbSetInputwxVtkBaseView( NULL );
    bbSetInputwxVtkBaseView2( NULL );
    bbSetInputwxVtkBaseView3( NULL );
    bbSetInputInteractionType(0);
    bbSetOutputWindowColorLevel( LstWindowColorLevel );
    bbSetOutputDirection(2);
    bbSetOutputInterpolation(true);
    bbSetOutputvtkRenderer(NULL);
    interactorwxvtkbaseview=NULL;
    interactorwxvtkbaseview2=NULL;
    interactorwxvtkbaseview3=NULL;
    bbSetOutputInteractorwxVtkBaseView_model(   interactorwxvtkbaseview  );
    bbSetOutputInteractorwxVtkBaseView_model2(  interactorwxvtkbaseview2 );
    bbSetOutputInteractorwxVtkBaseView_model3(  interactorwxvtkbaseview3 );
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void wxVtkBaseView_Info::bbUserInitializeProcessing()
{
//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any
    bbSetOutputInteractorwxVtkBaseView_model(NULL);
    bbSetOutputInteractorwxVtkBaseView_model2(NULL);
    bbSetOutputInteractorwxVtkBaseView_model3(NULL);
}

//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void wxVtkBaseView_Info::bbUserFinalizeProcessing()
{
//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
}

}// EO namespace bbcreaMaracasVisu


